package cc.toph.simplycompat.config;

import cc.toph.simplycompat.SimplyCompat;

public class Config {

    //    public static final String CONFIG_NAME = SimplyCompat.MOD_ID + SimpleConfig.FILE_EXTENSION;
    public static SimpleConfig CONFIG;
    private static final ConfigProvider PROVIDER = new ConfigProvider();


    // TODO: Move some of this stuff into ConfigRegistry
    public static final class WeaponAttributes {
        public static float COPPER;
        public static float STEEL;
        public static float TEST;
    }


    public static void registerConfigs() {
        // Load config 'simplycompat.config', if it isn't present create one
        // Temp Default Empty Provider to load config
        CONFIG = SimpleConfig.of(SimplyCompat.MOD_ID).provider(PROVIDER).request();
        initializeConfigs();
        CONFIG.update();

    }

    // Overloaded registerConfig for float
    private static float registerConfig(String key, float defaultValue, String comment) {
        PROVIDER.addKeyValuePair(key, defaultValue, comment);
        // Cast needed because getOrDefault for numbers returns double
        return (float) CONFIG.getOrDefault(key, defaultValue);
    }

    // Overloaded registerConfig for int
    private static int registerConfig(String key, int defaultValue, String comment) {
        PROVIDER.addKeyValuePair(key, defaultValue, comment);
        return CONFIG.getOrDefault(key, defaultValue);
    }

    // Overloaded registerConfig for double
    private static double registerConfig(String key, double defaultValue, String comment) {
        PROVIDER.addKeyValuePair(key, defaultValue, comment);
        return CONFIG.getOrDefault(key, defaultValue);
    }

    // Overloaded registerConfig for String
    private static String registerConfig(String key, String defaultValue, String comment) {
        PROVIDER.addKeyValuePair(key, defaultValue, comment);
        return CONFIG.getOrDefault(key, defaultValue);
    }

    // Overloaded registerConfig for boolean
    private static boolean registerConfig(String key, boolean defaultValue, String comment) {
        PROVIDER.addKeyValuePair(key, defaultValue, comment);
        return CONFIG.getOrDefault(key, defaultValue);
    }


    // Initialize config fields in one step
    private static void initializeConfigs() {
        WeaponAttributes.COPPER = registerConfig(
                "copper_damageModifier",
                3.0f,
                "Copper Damage Modifier"
        );

        WeaponAttributes.STEEL = registerConfig(
                "steel_damageModifier",
                5.0f,
                "Steel Damage Modifier"
        );
    }
}