package cc.toph.simplycompat.config;

import cc.toph.simplycompat.SimplyCompatExpectPlatform;

import java.util.HashMap;

public class ConfigProvider implements SimpleConfig.DefaultConfig {
    // Key: config key (e.g. "copper_damageModifier")
    // Value: Pair(value, comment)
    private final HashMap<String, String> configMap = new HashMap<>();
    private String contents = String.format("""
            ## Simply Compat Config
            ## Version: %s
            
            """, SimplyCompatExpectPlatform.getVersion());

    public void addKeyValuePair(String key, Object value, String comment) {
        String stringValue = String.valueOf(value); // safely handle `null` too
        configMap.put(key, stringValue);
        contents += String.format("""
                # %s
                %s = %s
                """, comment, key, value);

    }

    @Override
    public HashMap<String, String> getMap() {
        return configMap;
    }

    @Override
    public String get(String namespace) {
        return contents;
    }

}

